git-commit.sh 16.1 KB
Newer Older
L
Linus Torvalds 已提交
1
#!/bin/sh
2 3
#
# Copyright (c) 2005 Linus Torvalds
4 5
# Copyright (c) 2006 Junio C Hamano

6
USAGE='[-a] [-s] [-v] [--no-verify] [-m <message> | -F <logfile> | (-C|-c) <commit>] [-u] [--amend] [-e] [--author <author>] [[-i | -o] <path>...]'
7
SUBDIRECTORY_OK=Yes
8
. git-sh-setup
9

J
Junio C Hamano 已提交
10 11 12 13 14 15 16 17 18 19 20
git-rev-parse --verify HEAD >/dev/null 2>&1 || initial_commit=t
branch=$(GIT_DIR="$GIT_DIR" git-symbolic-ref HEAD)

case "$0" in
*status)
	status_only=t
	unmerged_ok_if_status=--unmerged ;;
*commit)
	status_only=
	unmerged_ok_if_status= ;;
esac
21 22 23 24 25 26 27

refuse_partial () {
	echo >&2 "$1"
	echo >&2 "You might have meant to say 'git commit -i paths...', perhaps?"
	exit 1
}

J
Junio C Hamano 已提交
28 29 30
THIS_INDEX="$GIT_DIR/index"
NEXT_INDEX="$GIT_DIR/next-index$$"
rm -f "$NEXT_INDEX"
J
Junio C Hamano 已提交
31
save_index () {
J
Junio C Hamano 已提交
32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59
	cp "$THIS_INDEX" "$NEXT_INDEX"
}

report () {
  header="#
# $1:
#   ($2)
#
"
  trailer=""
  while read status name newname
  do
    printf '%s' "$header"
    header=""
    trailer="#
"
    case "$status" in
    M ) echo "#	modified: $name";;
    D*) echo "#	deleted:  $name";;
    T ) echo "#	typechange: $name";;
    C*) echo "#	copied: $name -> $newname";;
    R*) echo "#	renamed: $name -> $newname";;
    A*) echo "#	new file: $name";;
    U ) echo "#	unmerged: $name";;
    esac
  done
  printf '%s' "$trailer"
  [ "$header" ]
J
Junio C Hamano 已提交
60 61 62
}

run_status () {
J
Junio C Hamano 已提交
63 64 65 66
    (
	# We always show status for the whole tree.
	cd "$TOP"

J
Junio C Hamano 已提交
67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82
	IS_INITIAL="$initial_commit"
	REFERENCE=HEAD
	case "$amend" in
	t)
		# If we are amending the initial commit, there
		# is no HEAD^1.
		if git-rev-parse --verify "HEAD^1" >/dev/null 2>&1
		then
			REFERENCE="HEAD^1"
			IS_INITIAL=
		else
			IS_INITIAL=t
		fi
		;;
	esac

J
Junio C Hamano 已提交
83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103
	# If TMP_INDEX is defined, that means we are doing
	# "--only" partial commit, and that index file is used
	# to build the tree for the commit.  Otherwise, if
	# NEXT_INDEX exists, that is the index file used to
	# make the commit.  Otherwise we are using as-is commit
	# so the regular index file is what we use to compare.
	if test '' != "$TMP_INDEX"
	then
	    GIT_INDEX_FILE="$TMP_INDEX"
	    export GIT_INDEX_FILE
	elif test -f "$NEXT_INDEX"
	then
	    GIT_INDEX_FILE="$NEXT_INDEX"
	    export GIT_INDEX_FILE
	fi

	case "$branch" in
	refs/heads/master) ;;
	*)  echo "# On branch $branch" ;;
	esac

J
Junio C Hamano 已提交
104
	if test -z "$IS_INITIAL"
J
Junio C Hamano 已提交
105
	then
106
	    git-diff-index -M --cached --name-status \
J
Junio C Hamano 已提交
107
		--diff-filter=MDTCRA $REFERENCE |
108 109 110 111 112
	    sed -e '
		    s/\\/\\\\/g
		    s/ /\\ /g
	    ' |
	    report "Updated but not checked in" "will commit"
J
Junio C Hamano 已提交
113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136
	    committable="$?"
	else
	    echo '#
# Initial commit
#'
	    git-ls-files |
	    sed -e '
		    s/\\/\\\\/g
		    s/ /\\ /g
		    s/^/A /
	    ' |
	    report "Updated but not checked in" "will commit"

	    committable="$?"
	fi

	git-diff-files  --name-status |
	sed -e '
		s/\\/\\\\/g
		s/ /\\ /g
	' |
	report "Changed but not updated" \
	    "use git-update-index to mark for commit"

137 138 139 140
        option=""
        if test -z "$untracked_files"; then
            option="--directory --no-empty-directory"
        fi
J
Junio C Hamano 已提交
141 142
	if test -f "$GIT_DIR/info/exclude"
	then
143
	    git-ls-files -z --others $option \
J
Junio C Hamano 已提交
144 145 146
		--exclude-from="$GIT_DIR/info/exclude" \
		--exclude-per-directory=.gitignore
	else
147
	    git-ls-files -z --others $option \
J
Junio C Hamano 已提交
148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166
		--exclude-per-directory=.gitignore
	fi |
	perl -e '$/ = "\0";
	    my $shown = 0;
	    while (<>) {
		chomp;
		s|\\|\\\\|g;
		s|\t|\\t|g;
		s|\n|\\n|g;
		s/^/#	/;
		if (!$shown) {
		    print "#\n# Untracked files:\n";
		    print "#   (use \"git add\" to add to commit)\n";
		    print "#\n";
		    $shown = 1;
		}
		print "$_\n";
	    }
	'
167

Y
Yasushi SHOJI 已提交
168
	if test -n "$verbose" -a -z "$IS_INITIAL"
169
	then
J
Junio C Hamano 已提交
170
	    git-diff-index --cached -M -p --diff-filter=MDTCRA $REFERENCE
171
	fi
J
Junio C Hamano 已提交
172 173
	case "$committable" in
	0)
J
Junio C Hamano 已提交
174 175 176 177 178 179 180
		case "$amend" in
		t)
			echo "# No changes" ;;
		*)
			echo "nothing to commit" ;;
		esac
		exit 1 ;;
J
Junio C Hamano 已提交
181 182 183
	esac
	exit 0
    )
J
Junio C Hamano 已提交
184 185
}

J
Junio C Hamano 已提交
186 187 188 189 190 191 192 193 194 195
trap '
	test -z "$TMP_INDEX" || {
		test -f "$TMP_INDEX" && rm -f "$TMP_INDEX"
	}
	rm -f "$NEXT_INDEX"
' 0

################################################################
# Command line argument parsing and sanity checking

196 197
all=
also=
J
Junio C Hamano 已提交
198
only=
199 200
logfile=
use_commit=
J
Junio C Hamano 已提交
201
amend=
202
edit_flag=
203 204 205 206
no_edit=
log_given=
log_message=
verify=t
J
Junio C Hamano 已提交
207
verbose=
208 209
signoff=
force_author=
210
only_include_assumed=
211
untracked_files=
212
while case "$#" in 0) break;; esac
213
do
214
  case "$1" in
215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234
  -F|--F|-f|--f|--fi|--fil|--file)
      case "$#" in 1) usage ;; esac
      shift
      no_edit=t
      log_given=t$log_given
      logfile="$1"
      shift
      ;;
  -F*|-f*)
      no_edit=t
      log_given=t$log_given
      logfile=`expr "$1" : '-[Ff]\(.*\)'`
      shift
      ;;
  --F=*|--f=*|--fi=*|--fil=*|--file=*)
      no_edit=t
      log_given=t$log_given
      logfile=`expr "$1" : '-[^=]*=\(.*\)'`
      shift
      ;;
235
  -a|--a|--al|--all)
236 237 238 239 240 241 242 243 244 245 246 247 248 249
      all=t
      shift
      ;;
  --au=*|--aut=*|--auth=*|--autho=*|--author=*)
      force_author=`expr "$1" : '-[^=]*=\(.*\)'`
      shift
      ;;
  --au|--aut|--auth|--autho|--author)
      case "$#" in 1) usage ;; esac
      shift
      force_author="$1"
      shift
      ;;
  -e|--e|--ed|--edi|--edit)
250
      edit_flag=t
251 252 253 254 255 256
      shift
      ;;
  -i|--i|--in|--inc|--incl|--inclu|--includ|--include)
      also=t
      shift
      ;;
J
Junio C Hamano 已提交
257 258 259 260
  -o|--o|--on|--onl|--only)
      only=t
      shift
      ;;
261
  -m|--m|--me|--mes|--mess|--messa|--messag|--message)
262 263
      case "$#" in 1) usage ;; esac
      shift
264 265 266 267 268 269 270 271 272
      log_given=m$log_given
      if test "$log_message" = ''
      then
          log_message="$1"
      else
          log_message="$log_message

$1"
      fi
273 274 275 276
      no_edit=t
      shift
      ;;
  -m*)
277 278 279 280 281 282 283 284 285
      log_given=m$log_given
      if test "$log_message" = ''
      then
          log_message=`expr "$1" : '-m\(.*\)'`
      else
          log_message="$log_message

`expr "$1" : '-m\(.*\)'`"
      fi
286 287 288 289
      no_edit=t
      shift
      ;;
  --m=*|--me=*|--mes=*|--mess=*|--messa=*|--messag=*|--message=*)
290 291 292 293 294 295 296 297 298
      log_given=m$log_given
      if test "$log_message" = ''
      then
          log_message=`expr "$1" : '-[^=]*=\(.*\)'`
      else
          log_message="$log_message

`expr "$1" : '-[^=]*=\(.*\)'`"
      fi
299 300 301 302 303 304 305
      no_edit=t
      shift
      ;;
  -n|--n|--no|--no-|--no-v|--no-ve|--no-ver|--no-veri|--no-verif|--no-verify)
      verify=
      shift
      ;;
J
Junio C Hamano 已提交
306 307 308 309 310 311
  --a|--am|--ame|--amen|--amend)
      amend=t
      log_given=t$log_given
      use_commit=HEAD
      shift
      ;;
312 313 314 315 316 317 318 319 320
  -c)
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=
      shift
      ;;
  --ree=*|--reed=*|--reedi=*|--reedit=*|--reedit-=*|--reedit-m=*|\
321 322
  --reedit-me=*|--reedit-mes=*|--reedit-mess=*|--reedit-messa=*|\
  --reedit-messag=*|--reedit-message=*)
323 324 325 326 327 328
      log_given=t$log_given
      use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
      no_edit=
      shift
      ;;
  --ree|--reed|--reedi|--reedit|--reedit-|--reedit-m|--reedit-me|\
329
  --reedit-mes|--reedit-mess|--reedit-messa|--reedit-messag|--reedit-message)
330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=
      shift
      ;;
  -C)
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=t
      shift
      ;;
  --reu=*|--reus=*|--reuse=*|--reuse-=*|--reuse-m=*|--reuse-me=*|\
346 347
  --reuse-mes=*|--reuse-mess=*|--reuse-messa=*|--reuse-messag=*|\
  --reuse-message=*)
348 349 350 351 352 353
      log_given=t$log_given
      use_commit=`expr "$1" : '-[^=]*=\(.*\)'`
      no_edit=t
      shift
      ;;
  --reu|--reus|--reuse|--reuse-|--reuse-m|--reuse-me|--reuse-mes|\
354
  --reuse-mess|--reuse-messa|--reuse-messag|--reuse-message)
355 356 357 358 359 360 361
      case "$#" in 1) usage ;; esac
      shift
      log_given=t$log_given
      use_commit="$1"
      no_edit=t
      shift
      ;;
362
  -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
363 364 365
      signoff=t
      shift
      ;;
J
Junio C Hamano 已提交
366 367 368
  -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
      verbose=t
      shift
369
      ;;
370 371 372 373 374 375
  -u|--u|--un|--unt|--untr|--untra|--untrac|--untrack|--untracke|--untracked|\
  --untracked-|--untracked-f|--untracked-fi|--untracked-fil|--untracked-file|\
  --untracked-files)
      untracked_files=t
      shift
      ;;
376
  --)
377 378 379
      shift
      break
      ;;
380
  -*)
381 382
      usage
      ;;
383
  *)
384 385
      break
      ;;
386
  esac
387
done
388
case "$edit_flag" in t) no_edit= ;; esac
389

J
Junio C Hamano 已提交
390 391 392
################################################################
# Sanity check options

J
Junio C Hamano 已提交
393 394 395 396 397 398 399 400 401
case "$amend,$initial_commit" in
t,t)
  die "You do not have anything to amend." ;;
t,)
  if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
    die "You are in the middle of a merge -- cannot amend."
  fi ;;
esac

402 403
case "$log_given" in
tt*)
404 405 406
  die "Only one of -c/-C/-F can be used." ;;
*tm*|*mt*)
  die "Option -m cannot be combined with -c/-C/-F." ;;
407 408
esac

J
Junio C Hamano 已提交
409 410
case "$#,$also,$only,$amend" in
*,t,t,*)
J
Junio C Hamano 已提交
411
  die "Only one of --include/--only can be used." ;;
J
Junio C Hamano 已提交
412
0,t,,* | 0,,t,)
J
Junio C Hamano 已提交
413
  die "No paths with --include/--only does not make sense." ;;
J
Junio C Hamano 已提交
414 415 416
0,,t,t)
  only_include_assumed="# Clever... amending the last one with dirty index." ;;
0,,,*)
J
Junio C Hamano 已提交
417
  ;;
J
Junio C Hamano 已提交
418
*,,,*)
J
Junio C Hamano 已提交
419
  only_include_assumed="# Explicit paths specified without -i nor -o; assuming --only paths..."
420
  also=
J
Junio C Hamano 已提交
421 422 423
  ;;
esac
unset only
J
Junio C Hamano 已提交
424 425 426 427 428 429 430 431 432 433 434
case "$all,$also,$#" in
t,t,*)
	die "Cannot use -a and -i at the same time." ;;
t,,[1-9]*)
	die "Paths with -a does not make sense." ;;
,t,0)
	die "No paths with -i does not make sense." ;;
esac

################################################################
# Prepare index to have a tree to be committed
J
Junio C Hamano 已提交
435

436
TOP=`git-rev-parse --show-cdup`
J
Junio C Hamano 已提交
437 438 439 440
if test -z "$TOP"
then
	TOP=./
fi
441 442 443

case "$all,$also" in
t,)
J
Junio C Hamano 已提交
444
	save_index &&
445
	(
J
Junio C Hamano 已提交
446
		cd "$TOP"
J
Junio C Hamano 已提交
447 448
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
449 450 451
		git-diff-files --name-only -z |
		git-update-index --remove -z --stdin
	)
J
Junio C Hamano 已提交
452
	;;
453
,t)
J
Junio C Hamano 已提交
454
	save_index &&
455 456
	git-ls-files --error-unmatch -- "$@" >/dev/null || exit

457
	git-diff-files --name-only -z -- "$@"  |
J
Junio C Hamano 已提交
458 459 460 461 462 463
	(
		cd "$TOP"
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
		git-update-index --remove -z --stdin
	)
464
	;;
465 466 467 468 469 470 471 472 473 474 475 476 477 478 479
,)
	case "$#" in
	0)
	    ;; # commit as-is
	*)
	    if test -f "$GIT_DIR/MERGE_HEAD"
	    then
		refuse_partial "Cannot do a partial commit during a merge."
	    fi
	    TMP_INDEX="$GIT_DIR/tmp-index$$"
	    if test -z "$initial_commit"
	    then
		# make sure index is clean at the specified paths, or
		# they are additions.
		dirty_in_index=`git-diff-index --cached --name-status \
J
Junio C Hamano 已提交
480
			--diff-filter=DMTU HEAD -- "$@"`
481
		test -z "$dirty_in_index" ||
J
Junio C Hamano 已提交
482
		refuse_partial "Different in index and the last commit:
483 484
$dirty_in_index"
	    fi
485
	    commit_only=`git-ls-files --error-unmatch -- "$@"` || exit
J
Junio C Hamano 已提交
486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508

	    # Build the temporary index and update the real index
	    # the same way.
	    if test -z "$initial_commit"
	    then
		cp "$THIS_INDEX" "$TMP_INDEX"
		GIT_INDEX_FILE="$TMP_INDEX" git-read-tree -m HEAD
	    else
		    rm -f "$TMP_INDEX"
	    fi || exit

	    echo "$commit_only" |
	    GIT_INDEX_FILE="$TMP_INDEX" \
	    git-update-index --add --remove --stdin &&

	    save_index &&
	    echo "$commit_only" |
	    (
		GIT_INDEX_FILE="$NEXT_INDEX"
		export GIT_INDEX_FILE
		git-update-index --remove --stdin
	    ) || exit
	    ;;
509 510 511 512
	esac
	;;
esac

J
Junio C Hamano 已提交
513 514 515 516
################################################################
# If we do as-is commit, the index file will be THIS_INDEX,
# otherwise NEXT_INDEX after we make this commit.  We leave
# the index as is if we abort.
517

J
Junio C Hamano 已提交
518
if test -f "$NEXT_INDEX"
519
then
J
Junio C Hamano 已提交
520 521 522
	USE_INDEX="$NEXT_INDEX"
else
	USE_INDEX="$THIS_INDEX"
523 524
fi

J
Junio C Hamano 已提交
525 526 527 528 529 530 531 532 533 534 535 536 537 538 539
GIT_INDEX_FILE="$USE_INDEX" \
    git-update-index -q $unmerged_ok_if_status --refresh || exit

################################################################
# If the request is status, just show it and exit.

case "$0" in
*status)
	run_status
	exit $?
esac

################################################################
# Grab commit message, write out tree and make commit.

540 541 542 543 544 545
if test t = "$verify" && test -x "$GIT_DIR"/hooks/pre-commit
then
	if test "$TMP_INDEX"
	then
		GIT_INDEX_FILE="$TMP_INDEX" "$GIT_DIR"/hooks/pre-commit
	else
J
Junio C Hamano 已提交
546
		GIT_INDEX_FILE="$USE_INDEX" "$GIT_DIR"/hooks/pre-commit
547 548
	fi || exit
fi
549

550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565
if test "$log_message" != ''
then
	echo "$log_message"
elif test "$logfile" != ""
then
	if test "$logfile" = -
	then
		test -t 0 &&
		echo >&2 "(reading log message from standard input)"
		cat
	else
		cat <"$logfile"
	fi
elif test "$use_commit" != ""
then
	git-cat-file commit "$use_commit" | sed -e '1,/^$/d'
566 567 568
elif test -f "$GIT_DIR/MERGE_HEAD" && test -f "$GIT_DIR/MERGE_MSG"
then
	cat "$GIT_DIR/MERGE_MSG"
J
Junio C Hamano 已提交
569 570 571
elif test -f "$GIT_DIR/SQUASH_MSG"
then
	cat "$GIT_DIR/SQUASH_MSG"
572
fi | git-stripspace >"$GIT_DIR"/COMMIT_EDITMSG
573 574 575

case "$signoff" in
t)
576 577 578 579 580 581
	{
		echo
		git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /
		'
582
	} >>"$GIT_DIR"/COMMIT_EDITMSG
583 584 585
	;;
esac

586
if test -f "$GIT_DIR/MERGE_HEAD" && test -z "$no_edit"; then
587
	echo "#"
A
Alex Riesen 已提交
588
	echo "# It looks like you may be committing a MERGE."
589 590 591 592
	echo "# If this is not correct, please remove the file"
	echo "#	$GIT_DIR/MERGE_HEAD"
	echo "# and try again"
	echo "#"
593
fi >>"$GIT_DIR"/COMMIT_EDITMSG
594

595
# Author
J
Junio C Hamano 已提交
596 597
if test '' != "$force_author"
then
598 599
	GIT_AUTHOR_NAME=`expr "z$force_author" : 'z\(.*[^ ]\) *<.*'` &&
	GIT_AUTHOR_EMAIL=`expr "z$force_author" : '.*\(<.*\)'` &&
J
Junio C Hamano 已提交
600 601 602 603 604
	test '' != "$GIT_AUTHOR_NAME" &&
	test '' != "$GIT_AUTHOR_EMAIL" ||
	die "malformatted --author parameter"
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL
elif test '' != "$use_commit"
605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634
then
	pick_author_script='
	/^author /{
		s/'\''/'\''\\'\'\''/g
		h
		s/^author \([^<]*\) <[^>]*> .*$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_NAME='\''&'\''/p

		g
		s/^author [^<]* <\([^>]*\)> .*$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p

		g
		s/^author [^<]* <[^>]*> \(.*\)$/\1/
		s/'\''/'\''\'\'\''/g
		s/.*/GIT_AUTHOR_DATE='\''&'\''/p

		q
	}
	'
	set_author_env=`git-cat-file commit "$use_commit" |
	LANG=C LC_ALL=C sed -ne "$pick_author_script"`
	eval "$set_author_env"
	export GIT_AUTHOR_NAME
	export GIT_AUTHOR_EMAIL
	export GIT_AUTHOR_DATE
fi

635
PARENTS="-p HEAD"
636
if test -z "$initial_commit"
J
Junio C Hamano 已提交
637
then
638
	if [ -f "$GIT_DIR/MERGE_HEAD" ]; then
J
Junio C Hamano 已提交
639
		PARENTS="-p HEAD "`sed -e 's/^/-p /' "$GIT_DIR/MERGE_HEAD"`
J
Junio C Hamano 已提交
640 641 642
	elif test -n "$amend"; then
		PARENTS=$(git-cat-file commit HEAD |
			sed -n -e '/^$/q' -e 's/^parent /-p /p')
643
	fi
644
	current=$(git-rev-parse --verify HEAD)
J
Junio C Hamano 已提交
645 646
else
	if [ -z "$(git-ls-files)" ]; then
J
Junio C Hamano 已提交
647
		echo >&2 Nothing to commit
J
Junio C Hamano 已提交
648 649 650
		exit 1
	fi
	PARENTS=""
651
	current=
652
fi
653

654 655 656
if test -z "$no_edit"
then
	{
657 658 659
		echo ""
		echo "# Please enter the commit message for your changes."
		echo "# (Comment lines starting with '#' will not be included)"
660 661 662 663 664 665 666
		test -z "$only_include_assumed" || echo "$only_include_assumed"
		run_status
	} >>"$GIT_DIR"/COMMIT_EDITMSG
else
	# we need to check if there is anything to commit
	run_status >/dev/null 
fi
667
if [ "$?" != "0" -a ! -f "$GIT_DIR/MERGE_HEAD" -a -z "$amend" ]
L
Linus Torvalds 已提交
668
then
J
Junio C Hamano 已提交
669
	rm -f "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
J
Junio C Hamano 已提交
670
	run_status
L
Linus Torvalds 已提交
671 672
	exit 1
fi
673

674
case "$no_edit" in
675
'')
676 677 678 679 680 681
	case "${VISUAL:-$EDITOR},$TERM" in
	,dumb)
		echo >&2 "Terminal is dumb but no VISUAL nor EDITOR defined."
		echo >&2 "Please supply the commit log message using either"
		echo >&2 "-m or -F option.  A boilerplate log message has"
		echo >&2 "been prepared in $GIT_DIR/COMMIT_EDITMSG"
682 683
		exit 1
		;;
684
	esac
685 686
	git-var GIT_AUTHOR_IDENT > /dev/null  || die
	git-var GIT_COMMITTER_IDENT > /dev/null  || die
687
	${VISUAL:-${EDITOR:-vi}} "$GIT_DIR/COMMIT_EDITMSG"
688 689
	;;
esac
690 691 692 693 694

case "$verify" in
t)
	if test -x "$GIT_DIR"/hooks/commit-msg
	then
695
		"$GIT_DIR"/hooks/commit-msg "$GIT_DIR"/COMMIT_EDITMSG || exit
696 697 698
	fi
esac

699 700 701 702 703 704 705 706 707 708 709 710
if test -z "$no_edit"
then
    sed -e '
        /^diff --git a\/.*/{
	    s///
	    q
	}
	/^#/d
    ' "$GIT_DIR"/COMMIT_EDITMSG
else
    cat "$GIT_DIR"/COMMIT_EDITMSG
fi |
J
Junio C Hamano 已提交
711
git-stripspace >"$GIT_DIR"/COMMIT_MSG
712 713 714 715 716

if cnt=`grep -v -i '^Signed-off-by' "$GIT_DIR"/COMMIT_MSG |
	git-stripspace |
	wc -l` &&
   test 0 -lt $cnt
717
then
718 719
	if test -z "$TMP_INDEX"
	then
J
Junio C Hamano 已提交
720
		tree=$(GIT_INDEX_FILE="$USE_INDEX" git-write-tree)
721 722 723 724
	else
		tree=$(GIT_INDEX_FILE="$TMP_INDEX" git-write-tree) &&
		rm -f "$TMP_INDEX"
	fi &&
725
	commit=$(cat "$GIT_DIR"/COMMIT_MSG | git-commit-tree $tree $PARENTS) &&
726 727
	rlogm=$(sed -e 1q "$GIT_DIR"/COMMIT_MSG) &&
	git-update-ref -m "commit: $rlogm" HEAD $commit $current &&
J
Junio C Hamano 已提交
728 729 730 731 732 733 734
	rm -f -- "$GIT_DIR/MERGE_HEAD" &&
	if test -f "$NEXT_INDEX"
	then
		mv "$NEXT_INDEX" "$THIS_INDEX"
	else
		: ;# happy
	fi
735 736 737 738
else
	echo >&2 "* no commit message?  aborting commit."
	false
fi
739
ret="$?"
J
Junio C Hamano 已提交
740
rm -f "$GIT_DIR/COMMIT_MSG" "$GIT_DIR/COMMIT_EDITMSG" "$GIT_DIR/SQUASH_MSG"
741 742 743 744
if test -d "$GIT_DIR/rr-cache"
then
	git-rerere
fi
745 746 747 748 749

if test -x "$GIT_DIR"/hooks/post-commit && test "$ret" = 0
then
	"$GIT_DIR"/hooks/post-commit
fi
750
exit "$ret"